import 'dart:convert';

import 'package:test/test.dart';
import 'package:atomic_state/atomic_state.dart';

import 'fixtures/counter.dart';

void main() {
  test('getState/updateState/setState', () {
    final store = Store([Counter()]);

    store.updateState<Counter>((counter) => counter.inc());

    expect(store.getState<Counter>().count, equals(1));
    expect(jsonEncode(store), equals('{"Counter":{"count":1}}'));
  });
}
